# mathetes-pipe.tcl

# by Pistos
# http://purepistos.net/mathetes
# January 9, 2006

# Be sure to put this file AFTER egghttp.tcl is loaded.

# In order for this script to function, you need an access key.
# Go to http://rome.purepistos.net/mathetes/register.rhtml to register for
# an access key.  Once you have your key, edit the line that reads
#     set mathetes_key "nokey"
# and change "nokey" to your access key.
# Don't forget to rehash your bot after the change.  ;)

# Otherwise, there's no need to change any variables, this script is plug-and-play.
# Just source it in your eggdrop.conf and you're off to the races!

# Be sure to check the Mathetes Statistics page to see how your
# users and your bot rank against all Mathetes remote access users!
# http://rome.purepistos.net/mathetes/stats.rhtml

# To have your bot talk, you must directly address it, using its nick.
# For example, if your bot's nick is MyLeetBot, then you go:
# <you> MyLeetBot: Hello!
# You can use either a colon or a comma after the nick, and there must
# be a space after the colon or comma.

# I would appreciate it if you came to irc.freenode.net #mathetes to
# let me know where you're using this script, and how you like the
# chat engine.

# Alternatively: pistos@purepistos.net or http://purepistos.net/forums

# ----------------------------------------------------------------------

bind pubm -|- "*" pub_mathetes
bind msgm -|- "*" msg_mathetes

set mathetes_pipe_version "2.3"
# HTTP timeout, in seconds.  Default is 4 minutes (240 seconds)
set mathetes_timeout 240
# This line below is where your access key goes!
set mathetes_key "no key"

if {![info exists egghttp(version)]} {
  putlog "egghttp.tcl was NOT successfully loaded."
}

proc mathetes_http {sock} {
global mathetes_convos
    set headers [egghttp:headers $sock]
    set body [egghttp:data $sock]
    regsub -all "\n" $body "" body
    set nick_chan $mathetes_convos($sock)
    set chan [lindex $nick_chan 0]
    set nick [lindex $nick_chan 1]
    
    if {[regexp {Mathetes: (.+?)<} "$body" whole_match group_match] == 1} {
        if {[string equal $group_match "</li>"]} {
            if { [string index $chan 0] != "#" } {
             puthelp "PRIVMSG $chan :..."
        } else {
             puthelp "PRIVMSG $chan :$nick: ..."
        }
        } else {
            if { [string index $chan 0] != "#" } {
             puthelp "PRIVMSG $chan :$group_match"
        } else {
             puthelp "PRIVMSG $chan :$nick: $group_match"
        }
        }
    } else {
        puthelp "PRIVMSG $chan :I seem to be experiencing technical difficulties.  Tell Pistos, or complain in http://purepistos.net/forums ."
    }
}

proc msg_mathetes {nick uhost handle rawtext} {
    global botnick
    set command [lindex $rawtext 0];
    set go "0"
    if { $command == "\*" } { set go "1" } else {
        if { [bind msg - $command] == "" && [bind msgm - $command] == ""  &&
                $command != "" && [string index $command 0] != "." } {
            set go "1"
        }
    }
    if { $go } {
        pub_mathetes $nick $uhost $handle $nick "${botnick}: ${rawtext}";
    }
}

proc pub_mathetes {nick uhost handle chan rawtext} {
    global mathetes_convos botnick mathetes_timeout mathetes_key
    set escaped_nick [string map {^ \\^ $ \\$ | \\| + \\+ * \\*} $botnick]
    # strip_codes is in a separate tcl.
    #set text [strip_codes "$rawtext"];
    set text "$rawtext"
    if {[regexp "(?i)^(\[\\\[\.,\|\=\+\_/\?\#\!\(\{\ \\\\-]|)${escaped_nick}(\ *|)\[^a-zA-Z1-9\ \]*\ .+" $text matchtext]} {
        regsub "(?i)^(\[\\\[\.,\|\=\+\_/\?\#\!\(\{\ \\\\-]|)${escaped_nick}(\[^a-zA-Z1-9\]*\ )" $text "" text
        set text [string trim $text]
        set queryvars "nick=$nick&key=$mathetes_key&input_line=$text"
        set sock [egghttp:geturl http://rome.purepistos.net/mathetes/ mathetes_http -query $queryvars -timeout $mathetes_timeout]
        set mathetes_convos($sock) [list $chan $nick]
    }
    return 0
}

putlog "mathetes-pipe.tcl v$mathetes_pipe_version by Pistos now loaded."
putlog "mathetes-pipe.tcl Privmsg/color/strange nick completion support by Avenger<avenger@buynet.com.br>"
